<template>
    <div>
        <el-card :body-style="cardBodyStyle">
            <el-row>
                <el-form :inline="true">
                    <el-form-item label="物料类别" style="margin-bottom: 0px;">
                        <el-input v-model="query.itemType" placeholder="请输入物料类别" clearable style="width: 200px;" />
                    </el-form-item>
                    <el-form-item label="物料名称" style="margin-bottom: 5px;" prop="itemNm">
                        <el-input v-model="query.itemNm" placeholder="请输入物料名称" clearable style="width: 200px;" />
                    </el-form-item>
                </el-form>
                <el-button type="primary" @click="handleSearch" plain>查询</el-button>
            </el-row>

        </el-card>
        <!-- <ButtonBar @search="handleSearch" @add="handleAdd"></ButtonBar> -->
        <el-card :body-style="cardBodyStyle">
            <el-table :data="tableData" border highlight-current-row @selection-change="handleSelectionChange">
                <el-table-column type="selection" fixed></el-table-column>
                <el-table-column type="index" label="序号" align="center" width="60">
                    <template #default="scope">
                        <span>{{ scope.$index + (currentPage - 1) * pageSize + 1 }}</span>
                    </template>
                </el-table-column>
                <el-table-column v-if="true" prop="itemType" label="物料类别" width="120" header-align="center"
                    align="center" show-overflow-tooltip>
                </el-table-column>
                <el-table-column v-if="true" prop="itemNm" label="物料名称" width="120" header-align="center" align="center"
                    show-overflow-tooltip>
                </el-table-column>
                <el-table-column v-if="true" prop="itemCode" label="物料编码" width="120" header-align="center"
                    align="center" show-overflow-tooltip>
                </el-table-column>
                <el-table-column v-if="true" prop="qty" label="库存量" width="120" header-align="center" align="center"
                    show-overflow-tooltip>
                </el-table-column>


                <el-table-column label="操作" header-align="center" align="center" width="100px">
                    <template #default="scope">
                        <el-button plain type="warning" @click="handleEdit(scope.row)">倒矿</el-button>
                    </template>
                </el-table-column>
            </el-table>
        </el-card>
        <el-card :body-style="cardBodyStyle">
            <el-pagination :current-page="currentPage" :page-size="pageSize" :page-sizes="pageSizes" :total="totalRows"
                background="background" layout="total, sizes, prev, pager, next, jumper" @size-change="handleSizeChange"
                @current-change="handleCurrentChange">
            </el-pagination>
        </el-card>

        <el-card :body-style="cardBodyStyle">
            <el-tabs type="border-card">
                <el-tab-pane label="倒矿记录">
                    <el-row>
                        <el-form :inline="true">
                            <el-form-item label="生产日期" style="margin-bottom: 0px;">
                                <el-date-picker v-model="query.produceDt" type="date" style="width: 200px;"
                                    value-format="YYYY-MM-DD" format="YYYY-MM-DD"
                                    placeholder="请选择生产时间"></el-date-picker>
                            </el-form-item>
                            <el-form-item label="生产班次" style="margin-bottom: 5px;" prop="prodShift">
                                <el-select v-model="query.prodShift" placeholder="请输入生产班次" clearable
                                    style="width: 200px;">
                                    <el-option label="1" value="1" />
                                    <el-option label="2" value="2" />
                                    <el-option label="3" value="3" />
                                </el-select>
                            </el-form-item>
                        </el-form>
                        <el-button type="primary" @click="handleSearchLog" plain>查询</el-button>
                    </el-row>
                    <el-table :data="tableDataLog" border highlight-current-row style="margin-top:10px;">
                        <el-table-column type="index" label="序号" align="center" width="60">
                            <template #default="scope">
                                <span>{{ scope.$index + (currentPageLog - 1) * pageSizeLog + 1 }}</span>
                            </template>
                        </el-table-column>
                        <el-table-column v-if="true" prop="produceDt" label="生产日期" width="120" header-align="center"
                            align="center" show-overflow-tooltip>
                        </el-table-column>
                        <el-table-column v-if="true" prop="prodShift" label="班次" width="80" header-align="center"
                            align="center" show-overflow-tooltip>
                        </el-table-column>
                        <el-table-column v-if="true" prop="itemType" label="物料类别" width="120" header-align="center"
                            align="center" show-overflow-tooltip>
                        </el-table-column>
                        <el-table-column v-if="true" prop="itemNm" label="物料名称" width="120" header-align="center"
                            align="center" show-overflow-tooltip>
                        </el-table-column>
                        <el-table-column v-if="true" prop="wgtDryDk" label="倒矿量" width="100" header-align="center"
                            align="center" show-overflow-tooltip>
                        </el-table-column>
                    </el-table>

                    <el-pagination :current-page="currentPageLog" :page-size="pageSizeLog" :page-sizes="pageSizesLog"
                        :total="totalRowsLog" background="background" layout="total, sizes, prev, pager, next, jumper"
                        @size-change="handleSizeChangeLog" @current-change="handleCurrentChangeLog"
                        style="margin-top:10px;">
                    </el-pagination>
                </el-tab-pane>
            </el-tabs>
        </el-card>

        <el-dialog :close-on-click-modal="false" draggable :title="dailogName" v-model="dialogVisible" width="850px"
            top="5vh" @open="openDialog">
            <el-descriptions>
                <el-descriptions-item label="物料类别:">{{ form.itemType }}</el-descriptions-item>
                <el-descriptions-item label="物料编码:">{{ form.itemCode }}</el-descriptions-item>
                <el-descriptions-item label="库存量:">{{ form.qty }}</el-descriptions-item>
            </el-descriptions>
            <el-form :model="form" label-width="80px" label-position="right" inline ref="ruleFormRef" :rules="rules">
                <el-row style="margin-top: 20px;">
                <el-col span="5">
                    <el-form-item label="生产日期" prop="produceDt">
                        <el-date-picker v-model="form.produceDt" type="date" style="width: 150px;"
                            value-format="YYYY-MM-DD" format="YYYY-MM-DD"></el-date-picker>
                    </el-form-item>
                </el-col>
                <el-col span="5">
                    <el-form-item label="班次" prop="prodShift">
                        <el-select v-model="form.prodShift" placeholder="请选择班次" style="width: 150px;">
                            <el-option label="1" value="1" />
                            <el-option label="2" value="2" />
                            <el-option label="3" value="3" />
                        </el-select>
                    </el-form-item>
                </el-col>
                <el-col span="5">
                    <el-form-item label="倒矿量" style="margin-bottom: 5px;" prop="wgtDryDk">
                        <el-input v-model="form.wgtDryDk" placeholder="请输入倒矿量" clearable style="width: 150px;" />
                    </el-form-item>
                </el-col>
            </el-row>
            </el-form>
            <template #footer>
                <div class="dialog-footer">
                    <el-button type="success" @click="handleSave(ruleFormRef)">保存</el-button>
                    <el-button type="danger" @click="handleCancelSave">取消</el-button>
                </div>
            </template>
        </el-dialog>


    </div>
</template>

<script setup>
import ButtonBar from '@/components/ButtonBar.vue'

import {
    ref,
    reactive,
    onMounted,
    getCurrentInstance
} from 'vue'

const {
    proxy
} = getCurrentInstance()

import tools from '@/tools'
const cardBodyStyle = ref(tools.style.card)
const inputStyle = ref(tools.style.input)

onMounted(() => {
    handleSearch()
    handleSearchLog()
})



/**
 *   查询
 */




const query = ref({
    type:'1'
})
const tableData = ref([])
const handleSearch = () => {
    currentPage.value = 1
    getTableData()
}

const getTableData = () => {
    var url = 'prd/Weight/queryDaoKuang'
    var param = {
        page: currentPage.value,
        rows: pageSize.value,
        params: JSON.stringify(query.value)
    }
    proxy.$axios.get(url, param).then(response => {
        if (response.data.code == '0') {
            tableData.value = response.data.data.records
            totalRows.value = response.data.data.total
        } else {
            ElMessage.error('操作失败！' + response.data.msg)
        }
    })
}
/**
 *   查询
 */
/**
 *   查询
 */


const tableDataLog = ref([])
const handleSearchLog = () => {
    currentPageLog.value = 1
    getTableDataLog()
}

const getTableDataLog = () => {
    var url = 'prd/Weight/query'
    var param = {
        page: currentPageLog.value,
        rows: pageSizeLog.value,
        params: JSON.stringify(query.value)
    }
    proxy.$axios.get(url, param).then(response => {
        if (response.data.code == '0') {
            tableDataLog.value = response.data.data.records
            totalRowsLog.value = response.data.data.total
        } else {
            ElMessage.error('操作失败！' + response.data.msg)
        }
    })
}
/**
 *   查询
 */

/**
 * 分页
 */
const currentPage = ref(1)
const totalRows = ref(0)
const pageSizes = ref([5, 10, 20, 30, 40])
const pageSize = ref(5)
const handleSizeChange = (val) => {
    pageSize.value = val
    getTableData()
}
const handleCurrentChange = (val) => {
    currentPage.value = val
    getTableData()
}
/**
 * 分页
 */
/**
 * 分页
 */
const currentPageLog = ref(1)
const totalRowsLog = ref(0)
const pageSizesLog = ref([5, 10, 20, 30, 40])
const pageSizeLog = ref(5)
const handleSizeChangeLog = (val) => {
    pageSizeLog.value = val
    getTableDataLog()
}
const handleCurrentChangeLog = (val) => {
    currentPageLog.value = val
    getTableDataLog()
}
/**
 * 分页
 */

/**
 * 新增
 */
const dailogName = ref('')
const dialogVisible = ref(false)
const form = ref({

})
const ruleFormRef = ref()
const rules = reactive({
    wgtDryDk: [{ required: true, message: '请输入倒矿量', trigger: 'change' | 'blur' },
    { pattern: /^[0-9]{1,15}(\.[0-9]{1,10})?$/, message: '请输入有效的数字', trigger: 'blur' | 'change' }],
    prodShift: [{ required: true, message: '请选择班次', trigger: 'change' | 'blur' }],
    produceDt: [{ required: true, message: '请选择生产日期', trigger: 'change' | 'blur' } ],
})

const handleAdd = () => {
    form.value = {
    }
    dailogName.value = '新增'
    dialogVisible.value = true
}
/**
 * 新增
 */


/**
 * 保存、修改、删除
 */

const openDialog = () => {
}

const handleSave = (ruleFormRef) => {
    ruleFormRef.validate((valid, fields) => {
        if (valid) {
            if (parseFloat(form.value.qty) > parseFloat(form.value.wgtDryDk) ) {
                var url = 'prd/Weight/daoKuang'
                var param = {
                    json: JSON.stringify(form.value),
                    userCode: localStorage.getItem('userCode'),
                    userName: localStorage.getItem('userName')
                }
                proxy.$axios.post(url, param).then(response => {
                    if (response.data.code == 0) {
                        form.value = response.data.data
                        ElMessage({
                            message: '保存成功',
                            type: 'success',
                        })
                        getTableData()
                        getTableDataLog()
                        dialogVisible.value = false
                    } else {
                        ElMessage({
                            message: '操作失败' + response.data.msg,
                            type: 'error'
                        })
                    }
                })
            }else{
                ElMessage({
                            message: '倒矿量大于库存量',
                            type: 'error'
                        })
            }
        } else {
            console.log('error submit!', fields)
        }
    })
}
const handleCancelSave = () => {
    dialogVisible.value = false
}
const handleEdit = (row) => {
    dailogName.value = '倒矿'
    dialogVisible.value = true
    form.value = row
    form.value.wgtDryDk = ''
}
const handleDelete = (row) => {
    ElMessageBox.confirm(
        '确定删除本条记录?',
        '提示', {
        confirmButtonText: '确认',
        cancelButtonText: '取消',
        type: 'warning',
        draggable: true,
    }
    )
        .then(() => {
            var url = 'prd/Weight/remove'
            var param = {
                id: row.id
            }
            proxy.$axios.post(url, param).then(response => {
                if (response.data.code == 0) {
                    ElMessage({
                        type: 'success',
                        message: '删除成功',
                    })
                    getTableData()
                } else {
                    ElMessage({
                        type: 'error',
                        message: '删除失败' + response.data.msg
                    });
                }
            });
        })
        .catch(() => {
            ElMessage({
                type: 'info',
                message: '已取消',
            })
        })
}

/**
 * 保存、修改、删除
 */

const multipleSelection = ref([])
const handleSelectionChange = (val) => {
    multipleSelection.value = val
}

const handleRemoveBatch = () => {
    console.log('handleRemoveBatch')

    if (multipleSelection.value.length < 1) {
        ElMessage({
            type: 'warning',
            message: '请选择要删除的数据!'
        })
        return
    }

    ElMessageBox.confirm('此操作将删除该数据, 是否继续?', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
    }).then(() => {
        var ids = []
        multipleSelection.value.forEach((item, index) => {
            ids.push(item.id)
        })
        var url = 'prd/Weight/removeBatch'
        var param = {
            ids: JSON.stringify(ids)
        }
        proxy.$axios.post(url, param).then(response => {
            if (response.data.code == '0') {
                ElMessage({
                    type: 'success',
                    message: '操作成功!',
                });
                getTableData()
                dialogVisible.value = false
            } else {
                ElMessage({
                    type: 'error',
                    message: '操作失败!' + response.data.msg
                });
            }
        })
    }).catch(() => {
        ElMessage({
            type: 'info',
            message: '已取消删除'
        })
    })
}

const handleEditBatch = () => {
    console.log('handleEditBatch')
    if (multipleSelection.value.length != 1) {
        ElMessage({
            type: 'warning',
            message: '请选择一条数据编辑!'
        })
        return
    }
    handleEdit(multipleSelection.value[0])
}

const handleUpload = () => {
    console.log('handleUpload')
}

const handleDownload = () => {
    console.log('handleDownload')
}

const handleImport = () => {
    console.log('handleImport')
}

const handleExport = () => {
    console.log('handleExport')
}

</script>

<style></style>